# Tile Game
# by Meme Tech

# Use the arrow keys or WASD to move the cursor (it wraps around the screen)
# Use any other key to clear the tile you are on and any adjacent tiles of the same colour!
# The game ends when the grid is full of tiles and you can't clear more than 4 tiles at once.
# (I intend on using space or enter to confirm, but they seem to be the only keys that don't work in the terminal)
# your score is directly proportional to the number of groups of tiles you clear, or how many "turns" you last

# I've updated the gray text on memetech.ca to show something you might be able to type in your OS terminal to run this game (?)

import time
import random
import os
from pynput import keyboard

grid = [[0 for i in range(5)] for j in range(10)]
score = 0

# colours!
tiles = [
    "\033[47m", # white
    "\033[44m", # blue
    "\033[41m", # red
    "\033[42m", # green
    "\033[43m", # yellow
    "\033[45m", # purple
]

def print_grid(x=None, y=None):
    global grid
    global tiles
    # clear the screen amd move the cursor to the top left
    print(end="\033[2J\033[1;1H")
    # if the terminal height is more than the grid height
    if os.get_terminal_size().lines > len(grid):
        # print a line
        print()
    # if it is more than the grid height + 3
    if os.get_terminal_size().lines > len(grid) + 3:
        # print a line
        print()
    for i in range(len(grid)):
        # print (term width / 2 - grid width) spaces
        print("\033[40m", end=" " * (os.get_terminal_size().columns // 2 - len(grid[i])))
        for j in range(len(grid[i])):
            if x == j and int(y) == i:
                print(tiles[grid[i][j]], end="><")
            elif x == j + 0.5 and int(y) == i:
                print(tiles[grid[i][j]], end=" >")
            elif x == j - 0.5 and int(y) == i:
                print(tiles[grid[i][j]], end="< ")
            else:
                print(tiles[grid[i][j]], end="  ")
        # black
        print("\033[40m")
print_grid()
def tick_grid(additions=0):
    global grid
    global tiles
    didanything = False
    for i in range(len(grid)):
        for j in range(len(grid[i])):
            # if the tile below this tile is 0 and this tile is not 0
            if i < len(grid) - 1 and grid[i+1][j] == 0 and grid[i][j] != 0:
                # move this tile down
                grid[i+1][j] = grid[i][j]
                grid[i][j] = 0
                didanything = True
                print_grid()
                time.sleep(0.05)
    if didanything:
        return tick_grid(additions)
    missed = additions
    for _ in range(additions):
        didanything = False
        for j in range(len(grid[0])):
            if grid[0][j] == 0:
                didanything = True
        if didanything:
            # pick a random tile at the top of the grid
            x = random.randint(0, len(grid[0]) - 1)
            while grid[0][x] != 0:
                x = random.randint(0, len(grid[0]) - 1)
            grid[0][x] = random.randint(1, len(tiles) - 1)
            print_grid()
            time.sleep(0.1)
            tick_grid(0)
            didanything = True
            missed -= 1
    if didanything:
        print_grid()
        time.sleep(0.1)
        return tick_grid(missed)
    return missed

x = 0
y = 0
tick_grid(10)
while True:
    score += 1 # this is a bad scoring system
    k = 0
    done = False
    while not (k == b" " or k == b"\n"):
        print_grid(x, y)
        if done:
            break
        with keyboard.Events() as events:
            for event in events:
                if event.key == keyboard.Key.left:
                    k = b"\x1b[D"
                    break
                if event.key == keyboard.Key.right:
                    k = b"\x1b[C"
                    break
                if event.key == keyboard.Key.up:
                    k = b"\x1b[A"
                    break
                if event.key == keyboard.Key.down:
                    k = b"\x1b[B"
                    break
                try:
                    k = event.key.char.encode()
                    break
                except AttributeError:
                    pass
        # is it left or A?
        if k == b"\x1b[D" or k == b"a":
            x -= 0.5
            if x < 0:
                x = len(grid[int(y)]) - 1
        # is it right or D?
        elif k == b"\x1b[C" or k == b"d":
            x += 0.5
            if x >= len(grid[int(y)]):
                x = 0
        # is it up or W?
        elif k == b"\x1b[A" or k == b"w":
            y -= 0.5
            if y < 0:
                y = len(grid) - 1
        # is it down or S?
        elif k == b"\x1b[B" or k == b"s":
            y += 0.5
            if y >= len(grid):
                y = 0
        # is it space or enter?
        else:
            done = True
            break
    # is it space or enter?
    # (we checked that in the loop so we don't need to deal with nested breaks)
    # (I do not like breaking in nested loops, it scares me)
    def clear_tile(x, y, c):
        global grid
        if grid[y][x] == 0:
            return
        if grid[y][x] != c:
            return
        grid[y][x] = 0
        if y > 0:
            clear_tile(x, y - 1, c)
        if y < len(grid) - 1:
            clear_tile(x, y + 1, c)
        if x > 0:
            clear_tile(x - 1, y, c)
        if x < len(grid[y]) - 1:
            clear_tile(x + 1, y, c)
    clear_tile(int(x), int(y), grid[int(y)][int(x)])
    print_grid()
    time.sleep(0.1)
    if tick_grid(5) > 1:
        time.sleep(0.2)
        # make all the tiles red
        for i in range(len(grid)):
            for j in range(len(grid[i])):
                grid[i][j] = 2
                time.sleep(0.05)
                print_grid()
        time.sleep(0.2)
        print("Game over! Your score was", end=str(score))
        print("!")
        exit()
